﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import ch.badmojo.color.Color;
	import ch.badmojo.color.ColorWheel;
	
	
	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 60;
		private var dotNum:Number = 0
		private var dots:Array = [];
		private var points:Array = [];
		private var lines:Array = [];
		private var posX:Number;
		private var posY:Number;
		private var posX1:Number;
		private var posY1:Number;
		private var point1:Point;
		private var vitesseMax:Number = 5;
		private var color : Color = new Color(21, 88, 188);
		private var wheel : ColorWheel = color.getRange([100,100], [100,100], 20);
		private var color2:Color;
		private var R:Number;
		private var G:Number;
		private var B:Number;
		
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			R = Math.random()*255;
			G = Math.random()*255;
			B = Math.random()*255;
			
			for(var i:Number = 0;i<quantity;i++){
				posX = Math.random()*stage.stageWidth;
				posY = Math.random()*stage.stageHeight;
				point1 = new Point(posX,posY);
				points.push(point1);
				/*if(i == 0){
					posX1 = posX;
					posY1 = posY;
				}else{*/
					posX1 = stage.stageWidth/2;
					posY1 = stage.stageHeight/2;
				//}
				addDot(posX,posY, posX1, posY1);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function addDot(x:Number,y:Number,x1:Number,y1:Number):void
		{
			var wheel:ColorWheel = new Color(R,G,B).toWarm(100);
			wheel.darken(20);
	        wheel.deSaturate(10);
			wheel.brighten(20);
			color2 = wheel.getColor();
			
			trace(x1 + "  |  " + y1 + "   |||   " + x + "  |  " + y);
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.beginFill(color2.getHex(),1);
			dots[dotNum].s.graphics.drawCircle(0,0,3);
			dots[dotNum].s.graphics.lineStyle(1,color2.getHex(),.3);
			dots[dotNum].s.graphics.drawCircle(0,0,8);
			dots[dotNum].s.graphics.drawCircle(0,0,10);
			dots[dotNum].s.graphics.drawCircle(0,0,12);
			//dots[dotNum].s.graphics.lineTo(300,400);
			dots[dotNum].s.graphics.lineTo(400,800);
			//lines[dotNum].l.graphics.lineTo(x,y);
			dots[dotNum].s.graphics.endFill();
			addChild(dots[dotNum].s);
			dotNum++;
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
			stage.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			stopdot();
		}
		private function stopdot():void
		{
			//var i:Number,t:Number;
			//var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(var j:int = 0; j < dotNum; j++){
				dots[j].x = mouseX;
				dots[j].y = mouseY;
			}
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
		}
		private function upHandler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,l:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				dots[i].s.rotation += 1;
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a)*s;
				vy = Math.sin(a)*s;
				x+=vx;
				y+=vy;
				if(x < 3 || x >= stage.stageWidth - 3 || y < 3 || y >= stage.stageHeight - 3){
					if(x<3){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-4){
						x = stage.stageWidth-4;
						vx*=-1;
					}
					if(y<3){
						y = 3;
						vy*=-1;
					}
					if(y>stage.stageHeight-4){
						y = stage.stageHeight-4;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle += Math.random()-.5;
				}
				if(Math.random()<.1){
					dots[i].v += Math.random()-.5;
					dots[i].v =  Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
}